# umi

_A Solana Framework for JavaScript clients._

Umi is a modular framework for building and using JavaScript clients for Solana programs. It provides a zero-dependency library that defines a set of core interfaces that libraries can rely on without being tied to a specific implementation. It is then up to the end-user to choose the implementation that best suits their needs. Umi also provides a set of default implementations and bundles that can be used out of the box allowing developers to get started quickly.

## Documentation

- [Installation](https://developers.metaplex.com/umi/getting-started)
- [Umi's interfaces](https://developers.metaplex.com/umi/interfaces)
- [Interface implementations](https://developers.metaplex.com/umi/implementations)
- [Public keys and signers](https://developers.metaplex.com/umi/public-keys-and-signers)
- [Connecting with an RPC](https://developers.metaplex.com/umi/rpc)
- [Sending transactions](https://developers.metaplex.com/umi/transactions)
- [Fetching accounts](https://developers.metaplex.com/umi/accounts)
- [Serializers](https://developers.metaplex.com/umi/serializers)
- [Uploading and downloading assets](https://developers.metaplex.com/umi/storage)
- [Sending Http requests](https://developers.metaplex.com/umi/http-requests)
- [Registering programs](https://developers.metaplex.com/umi/programs)
- [Umi plugins](https://developers.metaplex.com/umi/plugins)
- [Generating Umi clients via Kinobi](https://developers.metaplex.com/umi/kinobi)
- [Umi helpers](https://developers.metaplex.com/umi/helpers)
- [Web3.js adapters](https://developers.metaplex.com/umi/web3js-adapters)
